

UseSinCosTable proc ; lpSinTable,dx, rot 
 ; ndx:= round(sin(a)*dx)
 ; [esp]:= Eip; [esp+4]:= dx; 
 ; [esp+8]:= lpSinTable; 
 
 mov eax,esp
 add eax,4
  mov esi,[eax+8]  ; lpSin
  mov ecx,[eax]    ; rot
  mov eax,[eax+4]  ; dx
 sub eax,4
 
 mov ecx,[esi+ecx*4]
 push ecx
 fld d.[esp]
 pop ecx
 push eax
 fimul d.[esp]
 fist d.[esp]
 pop eax
 
 pop ecx   ; EIP
  pop edx  ; v1
  pop edx  ; v2
  pop edx  ; v3
 push ecx  ; 
 
 RET
UseSinCosTable endp    ; Result at eax

GetA proc  
 ; The formula is a:= (22/7)/180
 
 fldpi
 xor eax,eax
 mov ax,#180
 push eax
 fidiv d.[esp]  ; phi/180
 pop eax
 
 ret
GetA endp     ; Result at st(0)

CreateATable proc ; lpATable
 ; At least it need 14.4 KB memory.


 pop ecx ; EIP
  pop esi ; lpATable
 push ecx
 
 xor ecx,ecx
 mov cx,#3600
 
 CAT_Loop:
 call GetA
 push ecx
  fimul d.[esp]
  fst d.[esp]
 pop eax
 
 mov [esi+ecx*4],eax
 
 dec ecx
 jnz CAT_Loop
 
 
 ret
CreateATable endp

CreateSinOrCosTable proc ; lpResultTable, lpATable, nState
  ; This Function need 14.4 Kbytes
  ; nState: 0-Sin
  ;         1-Cos
  
 pop eax
  pop edx ;nState
  pop esi ;lpATable
  pop edi ;lpSinTable
 push eax
 
 xor ecx,ecx
 mov cx,#3600
CST_Loop:
 mov eax,[esi]
 push eax
 fld d.[esp]
 cmp dl,1
 jz CST_it_Cos
 fsin
 jmp CST_it_done
CST_it_Cos:
 fcos
CST_it_Done:
 fst d.[esp]
 pop eax
 mov [edi+ecx*4],eax
 dec ecx
 jnz CST_Loop
 
 
 ret
CreateSinorCosTable endp

plusone:
db 0,0,80,3f
half:
db 0,0,0,3f


jmp:


